//Book − Digital Logic Circuit Analysis and Design
//Authors - Victor P.Nelson, H. Troy Nagle, J. David Irwin, Bill D. Carroll
//Scilab Version - 6.1.0 ; OS - Windows

//Chapter 1; Example 1.62
//Two possible interpretation of the 8 bit fixed point number 11101010

clc
clear

a=11101010
n=8

//Fixed-point integer representation

q=1                //Intializing the column value of matrix b to 1
for i=1:n          //Entering the binary bits into a matrix
    r=modulo(a,10)
    b(1,q)=r
    a=a/10
    a=floor(a)
    q=q+1
end
s=b(1,q-1)         //Separating the sign bit from the binary number
x=0                //Initializing binary number to 0
if s==0 then
    disp("true")
    for m=1:q-2    //Multiplying each bits with its corresponding positional value and adding
        c=m-1
        x=x+b(1,m)*10^c
    end
    disp("Positive integer representation",x)
else
    for m=1:q-2    //Multiplying each bits with its corresponding positional value and adding
        c=m-1
        x=x+b(1,m)*2^c
    end
    x=bitcmp(x,n-1)//Bitwise complement of decimal number
    x=dec2bin(x)   //Decimal to binary conversion
    x=strtod(x)    //String to decimal conversion
    disp("Negative integer representation",-x)
end

//Fixed-point fraction representation

y=x/10^(n-1)
if s==0 then
    disp("Positive fraction representation",y)
else
    disp("Negative fraction representation",-y)
end
